
MEMORY {
// Memory map for the MPC5744P

//   16KB of UTEST flash starting at 0x00400000.
//   96KB of data flash starting at 0x00800000.
//  416KB of small flash blocks starting at 0x00f98000.
// 2048KB of large flash blocks starting at 0x01000000.

    flash_rsvd1  : ORIGIN = 0x00400000, LENGTH = 0x00b98000
    flash_memory : ORIGIN = 0x00f98000,	LENGTH = 0x00268000 // small and large flash blocks
    flash_rsvd2  : ORIGIN = .,          LENGTH = 0 

// 384KB of system SRAM starting at 0x40000000
    dram_rsvd1   : ORIGIN = 0x40000000, LENGTH = 0x100 // reserved for interrupt vectors
    dram_reset   : ORIGIN = .,	        LENGTH = 0
    dram_memory  : ORIGIN = .,          LENGTH = 384K-0x100
    dram_rsvd2   : ORIGIN = .,          LENGTH = 0
}
DEFAULTS {
    stack_reserve = 32k
    heap_reserve = 32k
}
//
// Program layout for running out of RAM.
//
//

SECTIONS
{
    .PPC.EMB.sdata0 	            	    	    ABS : > dram_memory
    .PPC.EMB.sbss0                            CLEAR ABS : > .

    .rchw						: > .
    .text  			            		: > dram_memory
    .vletext 				    		: > .
    .syscall 				    		: > .
    .secinfo 				    		: > .
    .rodata 				    		: > .
    .toc 				    		: > .
    .sdata2 				    		: > .
    .opd 				    		: > .
    .fixaddr			 	   		: > .
    .fixtype						: > .

    .sdabase 		        	      ALIGN(16) : > dram_memory	
    .sdata 						: > .
    .sbss 						: > .
    .data 						: > .
    .bss 		  				: > .
    .ghcovfz 					  CLEAR	: > .
    .ghcovcz 					  CLEAR	: > .
    .ghcovdz 					  CLEAR	: > .
    .heap                  ALIGN(16) PAD(heap_reserve)  : > .   
    .stack                 ALIGN(16) PAD(stack_reserve) : > .

//
// These special symbols mark the bounds of RAM and ROM memory.
// They are used by the MULTI debugger.
//
    __ghs_ramstart  = MEMADDR(dram_rsvd1);
    __ghs_ramend    = MEMENDADDR(dram_memory);
    __ghs_romstart  = MEMADDR(flash_rsvd1);
    __ghs_romend    = MEMENDADDR(flash_rsvd2);
    
}
